const express = require('express');
const app = express();
const port = 3000;

// set template engine to Pug
app.set('view engine', 'pug');

// Using express.urlencoded middleware
app.use(express.urlencoded({
  extended: true
}));

// import route handlers
var homeRoutes = require('./routes/home');
var serverRoutes = require('./routes/server');

// define routes
app.get('/', homeRoutes.getIndex);
app.get('/server/create', serverRoutes.getCreate);
app.post('/server/create', serverRoutes.postCreate);
app.get('/server/:serverName/start', serverRoutes.getStart);
app.get('/server/:serverName/stop', serverRoutes.getStop);

// set Express to serve static files (ideally this is only used in development)
app.use(express.static('./static/'));

// start Express.js app
app.listen(port, () => {
  console.log(`MCST has started and is listening on port ${port}.`);
});
